/*
#define CURRENT_LOW_TO_HIGH 13
#define CURRENT_HIGH_TO_LOW 25
#define CURRENT_SHORT 500

#define SPEED_LOW 45
#define SPEED_MID 100
#define SPEED_HIGH 255
*/

#define CURRENT_LOW_TO_HIGH 33  // Значение измеренного тока, при котором нужно раскручивать полностью двигатель(при переменном резисторе выставленном примерно на середину)
#define CURRENT_HIGH_TO_LOW 60  // Значение измеренного тока, при котором считаем что сверло просверлило и не встречает сопротивления
#define CURRENT_SHORT 750       // Значение измеренного тока, при котором считаем, что двигатель заклинило. Измеряем в мониторе порта при максимальных оборотах и заклинивании.

#define SPEED_LOW 65            // Минимальная скорость двигателя - до 255
#define SPEED_MID 140           // Разгонная скорость двигателя - до 255
#define SPEED_HIGH 255          // Максимальная скорость двигателя- до 255

unsigned char mode;
unsigned char count_short;

void setup() {
  TCCR2B = TCCR2B & 0b11111000 | 0x03; // ШИМ на 11 и 3 ноге 976.5625 Гц
  Serial.begin(9600);
  analogReference(INTERNAL);
  pinMode(3, OUTPUT);
  analogWrite(3,SPEED_LOW);
  delay(500);
}

// Функция считывания значения с шунта с последующим усреднением
unsigned int readCurrent(void)
{
  unsigned char i;
  unsigned int temp_current=0;
  for (i=0;i<16;i++)
      {
        temp_current= temp_current+analogRead(A1);
        delay(1);
      }
  temp_current=temp_current>>4;
  return temp_current; 
}

// Функция считывания значения с переменного резистора с последующим усреднением
unsigned int readVar(void)
{
  unsigned char i;
  unsigned int temp_var=0;
  for (i=0;i<8;i++)
      {
        temp_var= temp_var+analogRead(A0);
        delay(1);
      }
  temp_var=temp_var>>3;
  return temp_var; 
}

// Основной цикл
void loop() {
unsigned int current= readCurrent();   // Считываем значение с шунта
unsigned int variable= readVar();   // Считываем значение с переменного резистора

if (variable <60)  // В минимальном положении переменного резистора
   {
    mode=3;
    analogWrite(3,0); // Останавливаем двигатель
    delay(50);
    goto end_smart;
   }

if (variable>920)  // В максимальном положении переменного резистора
   {
    mode=4;
    analogWrite(3,SPEED_HIGH); // Максимальная скорость двигателя
    delay(50);
    goto end_smart;
   }

if (mode>1)    // Если до этого были крайние положения переменного резистора- восстанавливаем нормальный режим работы
    {
     analogWrite(3,SPEED_LOW);
     delay(200);
     mode=0;
     count_short=0;
     goto end_smart;      
    }
    
// Основной алгоритм управления сверлилкой
if (mode==1)
   {
    if (current<CURRENT_HIGH_TO_LOW) // Если пропала нагрузка на сверло- снижаем скорость
       {
        analogWrite(3,SPEED_LOW);
        delay(200);
        mode=0;
        count_short=0;
       }
    if (current>CURRENT_SHORT)  // Если заклинило- то пытаемся прокрутить
       {
        analogWrite(3,0);
        delay(400);
        analogWrite(3,SPEED_HIGH);
        delay(500);
        count_short++;

        if(count_short>3)  // Если количество попыток прокрутить сверло превышает, то на 10 секунд останавливаем двигатель
          {
           analogWrite(3,0);
           delay(10000); 
          }
        
       }
       
   }
    else {
          if (current>(CURRENT_LOW_TO_HIGH+variable/100))  // Если пошла нагрузка на сверло- раскручиваем двигатель в 2 ступени
             {
              analogWrite(3,SPEED_MID);
              delay(300);
              analogWrite(3,SPEED_HIGH);
              delay(200);
              mode=1;
             }
         }


 end_smart:        
// Выводим отладочную информацию в монитор порта        
Serial.print("cur=");
Serial.print(current);
Serial.print(" mode=");
Serial.print(mode);
Serial.print(" var=");
Serial.println(variable);

delay(20);                       
}
